M .gitignore => .gitignore +1 -0
@@ 62,3 62,4 @@ stamp-h[0-9]
/guix-daemon
/test-tmp
/nix/scripts/list-runtime-roots
+/test-env
M Makefile.am => Makefile.am +2 -2
@@ 181,10 181,10 @@ TEST_EXTENSIONS = .scm .sh
AM_TESTS_ENVIRONMENT = abs_top_srcdir="$(abs_top_srcdir)"
-SCM_LOG_COMPILER = $(top_builddir)/pre-inst-env $(GUILE)
+SCM_LOG_COMPILER = $(top_builddir)/test-env $(GUILE)
AM_SCM_LOG_FLAGS = --no-auto-compile -L "$(top_srcdir)"
-SH_LOG_COMPILER = $(top_builddir)/pre-inst-env $(SHELL)
+SH_LOG_COMPILER = $(top_builddir)/test-env $(SHELL)
AM_SH_LOG_FLAGS = -x -e
EXTRA_DIST = \
M config-daemon.ac => config-daemon.ac +6 -0
@@ 92,6 92,12 @@ if test "x$guix_build_daemon" = "xyes"; then
dnl Check for <linux/fs.h> (for immutable file support).
AC_CHECK_HEADERS([linux/fs.h])
+ dnl Temporary directory used to store the daemon's data.
+ AC_MSG_CHECKING([for unit test root])
+ GUIX_TEST_ROOT="`pwd`/test-tmp"
+ AC_MSG_RESULT([$GUIX_TEST_ROOT])
+ AC_SUBST([GUIX_TEST_ROOT])
+
AC_CONFIG_FILES([nix/scripts/list-runtime-roots],
[chmod +x nix/scripts/list-runtime-roots])
fi
M configure.ac => configure.ac +3 -2
@@ 104,9 104,10 @@ AC_CONFIG_FILES([Makefile
guix-download
guix-import
guix-package
- pre-inst-env])
+ pre-inst-env
+ test-env])
AC_CONFIG_COMMANDS([commands-exec],
- [chmod +x guix-build guix-download guix-import guix-package pre-inst-env])
+ [chmod +x guix-build guix-download guix-import guix-package pre-inst-env test-env])
AC_OUTPUT
M daemon.am => daemon.am +3 -6
@@ 155,15 155,12 @@ EXTRA_DIST += \
nix/AUTHORS \
nix/COPYING
-# Temporary directory used to store the daemon's data.
-test_root = $(abs_top_builddir)/test-tmp
-
AM_TESTS_ENVIRONMENT += \
- top_builddir="$(abs_top_builddir)" \
- TEST_ROOT="$(test_root)"
+ top_builddir="$(abs_top_builddir)"
TESTS += \
tests/guix-daemon.sh
clean-local:
- -rm -rf "$(test_root)"
+ -find "$(GUIX_TEST_ROOT)" | xargs chmod +w
+ -rm -rf "$(GUIX_TEST_ROOT)"
A test-env.in => test-env.in +53 -0
@@ 0,0 1,53 @@
+#!/bin/sh
+
+# Guix --- Nix package management from Guile. -*- coding: utf-8 -*-
+# Copyright (C) 2012 Ludovic Courtès <ludo@gnu.org>
+#
+# This file is part of Guix.
+#
+# Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Guix. If not, see <http://www.gnu.org/licenses/>.
+
+# Usage: ./test-env COMMAND ARG...
+#
+# Run the daemon in the build directory, and run COMMAND within
+# `pre-inst-env'. This is used to run unit tests with the just-built
+# daemon, unless `--disable-daemon' was passed at configure time.
+
+if [ -x "@abs_top_builddir@/guix-daemon" ]
+then
+ NIX_SUBSTITUTERS="" # don't resort to substituters
+ NIX_IGNORE_SYMLINK_STORE=1 # in case the store is a symlink
+ NIX_STORE_DIR="@GUIX_TEST_ROOT@/store"
+ NIX_LOCALSTATE_DIR="@GUIX_TEST_ROOT@/var"
+ NIX_LOG_DIR="@GUIX_TEST_ROOT@/var/log/nix"
+ NIX_STATE_DIR="@GUIX_TEST_ROOT@/var/nix-$$" # allow for parallel tests
+ NIX_DB_DIR="@GUIX_TEST_ROOT@/db"
+ NIX_ROOT_FINDER="@abs_top_builddir@/nix/scripts/list-runtime-roots"
+ export NIX_SUBSTITUTERS NIX_IGNORE_SYMLINK_STORE NIX_STORE_DIR \
+ NIX_LOCALSTATE_DIR NIX_LOG_DIR NIX_STATE_DIR NIX_DB_DIR \
+ NIX_ROOT_FINDER
+
+ # Do that because store.scm calls `canonicalize-path' on it.
+ mkdir -p "$NIX_STORE_DIR"
+
+ # Launch the daemon without chroot support because is may be
+ # unavailable, for instance if we're not running as root.
+ "@abs_top_builddir@/guix-daemon" --disable-chroot &
+
+ daemon_pid=$!
+ trap "kill $daemon_pid ; rm -rf $NIX_STATE_DIR" EXIT
+fi
+
+"@abs_top_builddir@/pre-inst-env" "$@"
+exit $?
M tests/guix-daemon.sh => tests/guix-daemon.sh +0 -19
@@ 22,27 22,8 @@
set -e
-NIX_SUBSTITUTERS="" # don't resort to substituters
-NIX_IGNORE_SYMLINK_STORE=1 # in case the store is a symlink
-NIX_STORE_DIR="$TEST_ROOT/store"
-NIX_LOCALSTATE_DIR="$TEST_ROOT/var"
-NIX_LOG_DIR="$TEST_ROOT/var/log/nix"
-NIX_STATE_DIR="$TEST_ROOT/var/nix"
-NIX_DB_DIR="$TEST_ROOT/db"
-NIX_ROOT_FINDER="$top_builddir/nix/scripts/list-runtime-roots"
-export NIX_SUBSTITUTERS NIX_IGNORE_SYMLINK_STORE NIX_STORE_DIR \
- NIX_LOCALSTATE_DIR NIX_LOG_DIR NIX_STATE_DIR NIX_DB_DIR \
- NIX_ROOT_FINDER
-
guix-daemon --version
guix-build --version
-# Launch the daemon without chroot support because is may be
-# unavailable, for instance if we're not running as root.
-guix-daemon --disable-chroot &
-
-daemon_pid=$!
-trap "kill $daemon_pid" EXIT
-
guix-build -e '(@ (distro packages bootstrap) %bootstrap-guile)'
guix-build coreutils -n